#         Script : serials v1.02 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2000-2003 Radical Computer Systems
#
# Original Platform : Linux 2.0.36
#                     Eggdrop v1.2.0+bel1
# Testing Platforms : Linux 2.2.16  (TCL v8.3)
#                     Eggdrop v1.6.6
#               And : SunOS 5.8  (TCL v8.3)
#                     Eggdrop v1.5.4
#
#    Description : Serials is another lame little tcl. All it does is
#                  provide a search function on a flat text file.
#                  Defualt setup is for a list of serial codes.
#
# Originally written 2 years ago. Never thought it was really worth
# releasing. But what the hell.
#        History : 03/29/2002 - First Release
#                  04/07/2002 - v1.01
#                              o Holly shit I'm stupid! I deleted the line
#                                that calls the damn search proc! So the
#                                scripts would just sit there! DUHDUHDUHDUH!
#                                "I would like to accept this Idiot Of The
#                                 Year award for all morons like myself..."
#                              o Added in easy way of searching multiple 
#                                files. (In case you seperate by group/alpha
#                                        or whatever..)
#                  07/13/2003 - v1.02
#                              o Added optional line number display
#                              o Added total lines display at end search
#
#
#   Future Plans : o None at the moment.
# o Command for users to add serials
#
#      Donations : https://www.paypal.com/xclick/business=pproper%40satx.rr.com
# (If you don't have PayPal and want to donate, EMail me for an address.
#  Will take money or hardware/computer donations)
#  Significant (or even non-significant donations) can be published on a
#  web site if you so choose.
#
# Author Contact :     Email - DProper@chaotix.net
#                   Homepage - http://www.chaotix.net/~dproper
#                        IRC - Primary Nick: DrN
#                     UseNet - alt.irc.bots.eggdrop
# Support Channels: #RCS @UnderNet.Org
#                   #RCS @DALnet
#                   #RCS @EFnet
#                   #RCS @GalaxyNet
#                   #RCS @Choatix Addiction
#            Other channels - Check contact page for current list
#
#                Current contact information can be located at:
#                 http://rcs.chaotix.net/contact.html
#
# New TCL releases are sent to the following sites as soon as they're released:
#
# FTP Site                   | Directory                     
# ---------------------------+-------------------------------
# ftp.chaotix.net            | /pub/RCS
# ftp.eggheads.org           | Various
#
# To subscribe to the RCS mailing list:
#  http://www.chaotix.net/mailman/listinfo/rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
#
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
#
# If you have a "too cool" modification, send it to me and it'll be
# included in the official. (With your credit)
#
# Commands Added:
#  Where     F CMD       F CMD         F CMD        F CMD
#  -------   - --------- - ----------- - ---------- - --------- - -------
#  Public:   - !serial   - @find       - !serials   - !search   - @search
#            - !list
#     MSG:   - serial
#     DCC:   
#
#
# Big thanks to LtGen of #tcl (UnderNet) for answering a question I had

set serialver "v1.02.01"
set cmdchar_ "!"
set maxsearch 20
#set serialdata "~/.serials"
set serialcontrib "To contribute to the list, send any serials to serials@chaotix.net"


# [0/1] Set this to 1 to show the line number in the output
set serials(showlinenumber) 1

# Format is:
# path/filename Description
# You can include multiple files to search for.
set serialdata {
 {~/.serials General Serial Database - Old Ass shit}
               }


proc cmdchar { } {
 global cmdchar_
 return $cmdchar_
}

bind pub - !serials pub_serialinform
bind pub - @find pub_serialinform
bind pub - @search pub_serialinform
bind pub - !search pub_serialinform
bind pub - !list pub_serialinform

proc pub_serialinform {nick uhost handle chan args} {
  global urlfile prefix totfound serialcontrib
    puthelp "NOTICE $nick :To search the serial database: [cmdchar]serial keyword"
    puthelp "NOTICE $nick :$serialcontrib"
  return 1
}



bind pub - [cmdchar]serial pub_serialsearch
proc pub_serialsearch {nick uhost handle chan args} {
  global urlfile prefix totfound
  if {[lindex $args 0] != ""} {

 set a [lindex $args 0]
 set b [lindex $a 0]
 set c [lrange $a 1 end]
 foreach ab $c {
  append b "*"
  append b $ab
               }

  doserialsearch $nick $b
  } else {
    puthelp "NOTICE $nick :Syntax: !serial <search string>"
  }
  return 1
}


proc msg_serialsearch {nick uhost handle args} {
  global urlfile prefix botnick totfound
  if {[lindex $args 0] != ""} {
 set a [lindex $args 0]
 set b [lindex $a 0]
 set c [lrange $a 1 end]
 foreach ab $c {
 append b "*"
 append b $ab
 }
  doserialsearch $nick $b
  } else {
    puthelp "NOTICE $nick :Syntax: /msg $botnick serial <search string>"
  }
  return 1
}

bind msg - serial msg_serialsearch

proc doserialsearch {nick data} {
global serialver maxsearch serialdata
    putserv "NOTICE $nick :Serial Search $serialver by DrN"
    putserv "NOTICE $nick :Searching Main Database for \"$data\""
    if {$maxsearch != 0} {putserv "NOTICE $nick :There is a limit of $maxsearch results in effect."}
    set data [string tolower $data]

foreach sdb $serialdata {
 set sdbf [lindex $sdb 0]
 set sdbd [lrange $sdb 1 end]
 putserv "NOTICE $nick :Searching $sdbd"
 searchserials $nick $sdbf $data
                        }


}

proc searchserials {nick database data} {
 global maxsearch serials
    set in [open $database r]
    set totfound 0
    set linenum 0

    while {![eof $in]} {
      set line [gets $in]
      incr linenum 1
      if {[string match "*$data*" [string tolower $line]]} {
       if {$serials(showlinenumber) == 1} {puthelp "NOTICE $nick :($linenum) $line"
           } else {
                   puthelp "NOTICE $nick :$line"
                  }

      if {$totfound > $maxsearch} {
                  puthelp "NOTICE $nick :There are over $maxsearch matches. Please norrow your search."
                  close $in
                  return 0
                                   }
        set totfound [expr $totfound + 1]
     }
    }
    close $in
    puthelp "NOTICE $nick :There was a total of $totfound out of $linenum entries matching your query."

}

putlog "Serials $serialver by David Proper (DrN) -: LoadeD :-"
return "Serials $serialver by David Proper (DrN) -: LoadeD :-"

